/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { FinancialIndicator } from "./FinancialIndicator";
import { String_$type, Number_$type, typeCast, fromEnum, markType } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var StrategyBasedIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StrategyBasedIndicator, _super);
    function StrategyBasedIndicator() {
        var _this = _super.call(this) || this;
        _this.ze();
        return _this;
    }
    StrategyBasedIndicator.prototype.ze = function () {
        this.yz = this.y0;
        this.ab = this.zd;
    };
    StrategyBasedIndicator.prototype.y6 = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.zf = function (a) {
    };
    StrategyBasedIndicator.prototype.y8 = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.y5 = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.zj = function (a, b, c) {
        var d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, function (e, f) { return (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue); }));
        StrategyBasedIndicator.y3.add(c);
        return d;
    };
    StrategyBasedIndicator.zi = function (a, b) {
        return StrategyBasedIndicator.zj(a, b, "Period");
    };
    StrategyBasedIndicator.zg = function (a, b) {
        return StrategyBasedIndicator.zj(a, b, "LongPeriod");
    };
    StrategyBasedIndicator.zk = function (a, b) {
        return StrategyBasedIndicator.zj(a, b, "ShortPeriod");
    };
    StrategyBasedIndicator.prototype.yc = function (a, b) {
        var c = this.uo(a, b);
        var d = this.up(c);
        return this.yz.b(c, d);
    };
    StrategyBasedIndicator.prototype.x9 = function (a, b) {
        var c = this.uo(a, b);
        if (b == 0) {
            return false;
        }
        if (!this.vk(this.yc(a, b))) {
            return false;
        }
        var d = this.up(c);
        if (this.x5 != null) {
            c.minimumValue = this.x5.c;
            c.maximumValue = this.x5.b;
        }
        var e = this.yz.a(c, d);
        for (var f = 0; f < this.ye && f < c.indicatorColumn.count; f++) {
            c.indicatorColumn.item(f, NaN);
        }
        if (this.uu != null && this.y2(c)) {
            this.uu.c1();
        }
        return e;
    };
    StrategyBasedIndicator.prototype.y2 = function (a) {
        var e_1, _a;
        if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
            var b = this.x5;
            this.x5 = new AxisRange(a.minimumValue, a.maximumValue);
            return this.y1(b, this.x5);
        }
        var c = 1.7976931348623157E+308;
        var d = -1.7976931348623157E+308;
        try {
            for (var _b = __values(fromEnum(a.indicatorColumn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (!isNaN_(e)) {
                    c = Math.min(c, e);
                    d = Math.max(d, e);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        var f = this.x5;
        this.x5 = new AxisRange(c, d);
        return this.y1(f, this.x5);
    };
    StrategyBasedIndicator.prototype.y1 = function (a, b) {
        if (a == null || b == null) {
            return true;
        }
        if (a.c != b.c) {
            return true;
        }
        if (a.b != b.b) {
            return true;
        }
        return false;
    };
    StrategyBasedIndicator.prototype.y7 = function (a) {
        if (a == -2147483648) {
            return 0;
        }
        if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
            a = this.indicatorColumn.count - 1;
        }
        if (a < 1) {
            return 1;
        }
        return a;
    };
    StrategyBasedIndicator.prototype.uo = function (a, b) {
        var c = _super.prototype.uo.call(this, a, b);
        c.indicatorColumn = this.indicatorColumn;
        c.period = this.y7(this.y6());
        c.shortPeriod = this.y7(this.y8());
        c.longPeriod = this.y7(this.y5());
        c.multiplier = this.y4();
        return c;
    };
    StrategyBasedIndicator.prototype.y4 = function () {
        return 1;
    };
    StrategyBasedIndicator.zh = function (a, b) {
        var c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, function (d, e) { return (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue); }));
        StrategyBasedIndicator.y3.add("Multiplier");
        return c;
    };
    StrategyBasedIndicator.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        if (StrategyBasedIndicator.y3.contains(b)) {
            if (this.uu != null && !this.uu.c1()) {
                this.us.b0.e(this.hk);
                this.x9(0, this.indicatorColumn.count);
                if (this.x6.ca) {
                    this.x6.b8.g$i();
                }
                this.pr(false);
            }
        }
    };
    StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
    StrategyBasedIndicator.y3 = new List$1(String_$type, 0);
    return StrategyBasedIndicator;
}(FinancialIndicator));
export { StrategyBasedIndicator };
